'This programme requires the FamaMacBeth add-in 
group rets pr*
group facs r_mkt1
smpl 1962:1 2014:6
scalar mean_rf=100*@mean(r_rf)
scalar mean_rm=@mean(r_mkt1)
fmb rets facs 
'Fama-MacBeth by regression and HAC standard errors
'create vector mean vector and beta vector
vector(25,1) mean_ret
vector(25,1) beta_coefs
!num=1
for %i 11 12 13 14 15 21 22 23 24 25 31 32 33 34 35 41 42 43 44 45 51 52 53 54 55 
vector a_{%i}=@mean(pr{%i})
matplace(mean_ret,a_{%i},!num,1)
equation eq_ret{%i}.ls pr{%i} C R_MKT1 
vector b_{%i}=eq_ret{%i}.@coefs(2)
matplace(beta_coefs,b_{%i},!num,1)
!num=!num+1
next
delete a_* eq_ret* b_*
pagecreate(page = cross) u 1 25
copy monthly\mean_ret cross\mean_ret 
copy monthly\beta_coefs cross\beta_coefs
pageselect cross
mtos(mean_ret, gr_mean)
mtos(beta_coefs, gr_beta)
group scatter gr_beta gr_mean
scatter.scat linefit
equation fama_mb.ls gr_mean= c(1)+c(2)*gr_beta
equation fama_mb1.ls(cov=hac) gr_mean= c(1)+c(2)*gr_beta


